<?php

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

function imagination(){

    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inDB   = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();

	
	$types=array("forum"=>"Форумы","comments"=>"Комментарии","blogs"=>"Блоги","vstrechi"=>"События");
	
    global $_LANG;

    $inCore->loadModel('imagination');
    $model = new cms_model_imagination();

	//Загрузка настроек встреч
	$cfg = $inCore->loadComponentConfig('imagination');
	// Проверяем включени ли компонент

	if(!$cfg['component_enabled']) { cmsCore::error404(); }
	
if(!isset($cfg['width'])) { $cfg['width']=400;}// => 400 
if(!isset($cfg['show_blogs'])) { $cfg['show_blogs']=1;}// => 1 
if(!isset($cfg['show_comments'])) { $cfg['show_comments']=0;}// => 1 
if(!isset($cfg['show_forum'])) { $cfg['show_forum']=0;}// => 1 
if(!isset($cfg['show_vstrechi'])) { $cfg['show_vstrechi']=0;}// => 1 
if(!isset($cfg['blogs_enabled'])) { $cfg['blogs_enabled']=1;}// => 1 
if(!isset($cfg['comments_enabled'])) { $cfg['comments_enabled']=0;}// => 1 
if(!isset($cfg['forum_enabled'])) { $cfg['forum_enabled']=0;}// => 1 
if(!isset($cfg['vstrechi_enabled'])) { $cfg['vstrechi_enabled']=0;}// => 1 
if(!isset($cfg['stolb'])) { $cfg['stolb']=2;}// => 2 
if(!isset($cfg['ppage'])) { $cfg['ppage']=10;}// => 10 
if(!isset($cfg['allowcomments'])) { $cfg['allowcomments']=1;}// => 1
if(!isset($cfg['b_style'])) { $cfg['b_style']="free";}// => 1	
	
	
$inPage->addPathway("Imagination", '/imagination');


	//Получаем параметры
	$page 		= $inCore->request('page', 'int', 1);
	$id 		= $inCore->request('id', 'int', '0');	
	$do 		= $inCore->request('do', 'str', 'all');

if($do=="selectimage")
{
	$image_id 		= $inCore->request('image_id', 'int', '0');	
	echo $model->get_photoitem($image_id,$cfg['width'],$cfg['allowcomments'],$cfg['b_style']);
	exit;
}

if($do=="imagination")
{
	$image_id 		= $inCore->request('image_id', 'int', '0');	
	echo $model->get_around($image_id,$cfg['b_style']);
	exit;
}


	$inPage->addHead('<link rel="stylesheet" href="/components/imagination/css/imagination.css">');
	$inPage->addHead('<link rel="stylesheet" href="/components/imagination/css/buttons.css">');

if ($do=='image'){
		$item=$inDB->get_fields('cms_imagination', "id='".$id."'", '*');
	
	if(!$item){ cmsCore::error404(); }
}
////////////////////////////////
	echo '<div class="imagination_type_menu">';

$all=$inDB->rows_count("`cms_imagination`","`published`='1'");
if($do=='all'){
		$addtitle="Лента изображений - ";
    echo'<span class="imagination_type_active">Лента изображений <sup style="font-size:11px;">'.$all.'</sup></span>';}else
    	{echo'<a class="imagination_type_link" href="/imagination/all">Лента изображений <sup style="font-size:11px;">'.$all.'</sup></a>';}
    
$blogs=$inDB->rows_count("`cms_imagination`","`published`='1' and `type`='blogs'");
	if($cfg['blogs_enabled']==1)
	{
		if($do=='blogs'){
		$addtitle="Изображения из блогов -";
    echo'<span class="imagination_type_active">Блоги<sup style="font-size:11px;">'.$blogs.'</sup></span>';}else
    	{echo'<a class="imagination_type_link" href="/imagination/blogs">Блоги<sup style="font-size:11px;">'.$blogs.'</sup></a>';}
    }
    
$comments=$inDB->rows_count("`cms_imagination`","`published`='1' and `type`='comments'");
	if($cfg['comments_enabled']==1)
	{
if($do=='comments'){
		$addtitle="Изображения из комментариев -";
    echo'<span class="imagination_type_active">Комментарии<sup style="font-size:11px;">'.$comments.'</sup></span>';}else
    	{echo'<a class="imagination_type_link" href="/imagination/comments">Комментарии<sup style="font-size:11px;">'.$comments.'</sup></a>';}
    }
    
$forum=$inDB->rows_count("`cms_imagination`","`published`='1' and `type`='forum'");
	if($cfg['forum_enabled']==1)
	{
if($do=='forum'){
	$addtitle="Изображения из форума -";
    echo'<span class="imagination_type_active">Форум<sup style="font-size:11px;">'.$forum.'</sup></span>';}else
    	{echo'<a class="imagination_type_link" href="/imagination/forum">Форум<sup style="font-size:11px;">'.$forum.'</sup></a>';}
    }
 
$vstrechi=$inDB->rows_count("`cms_imagination`","`published`='1' and `type`='vstrechi'");
	if($cfg['vstrechi_enabled']==1)
	{
if($do=='vstrechi'){
	$addtitle="Изображения из событий/встреч -";
    echo'<span class="imagination_type_active">События<sup style="font-size:11px;">'.$vstrechi.'</sup></span>';}else
    	{echo'<a class="imagination_type_link" href="/imagination/vstrechi">События<sup style="font-size:11px;">'.$vstrechi.'</sup></a>';} 
    }
 
        
	echo'</div>';

////////////////////////////////


if ($do=='image'){
	
	?>
	<script>
	function selectimage(image_id)
	{
	$("#selectimage").html('<img src="/components/imagination/images/ajax-loader.gif" border="0" />');
	$("#selectimage").load("/imagination/selectimage", {'image_id': image_id});
	}
	
	function imagination(image_id)
	{
	$("#imagination").html('<img src="/components/imagination/images/ajax-loader.gif" border="0" />');
	$("#imagination").load("/imagination/imagination", {'image_id': image_id});
	}
	</script>

	

	<?
	echo "<table width='100%'>";
	
	echo "<tr>";
	echo "<td width='120' align='center' valign='top'>";
	$page_title="Изображение:".$item['id']." - ".$item['title'];
	$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);
	echo "<div id='imagination'>";
	echo $model->get_around($id,$cfg['b_style']);
	echo "</div>";

	echo "</td><td>";
	echo "<div id='selectimage'>";
	echo $model->get_photoitem($id,$cfg['width'],$cfg['allowcomments'],$cfg['b_style']);
	echo "</div>";
			echo "</td></tr></table>";
	

}


/*все*/
if ($do=='all' or $do=='blogs' or $do=='forum' or $do=='comments' or $do=='vstrechi'){


 	$user_id = $inUser->id;
	$page_title= $addtitle." Imagination - Страница: ".$page."";
	$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);
	echo "<h3>Imagination - изображения из комментариев, блогов и форума.</h3>";


		if($do=="all")
	{$total=$all; $type="";
	}else
		if($do=="blogs")
	{$total=$blogs; $type=" and `type`='blogs' ";
	}else
		if($do=="comments")
	{$total=$comments; $type=" and `type`='comments' ";
	}else
		if($do=="forum")
	{$total=$forum; $type=" and `type`='forum' ";}
	else
		if($do=="vstrechi")
	{$total=$vstrechi; $type=" and `type`='vstrechi' ";}
	$pagebar= cmsPage::getPagebar($total, $page, $cfg['ppage'], '/imagination/'.$do.'/page-%page%');
	echo $pagebar;

$sql = "SELECT * FROM `cms_imagination` WHERE `published`='1'".$type." order by pubdate desc LIMIT ".($page-1)*$cfg['ppage'].",".$cfg['ppage']."";//каменты
echo "<table width='100%'>";
$j=0;
$jp=$cfg['stolb'];
        $result = $inDB->query($sql);
        while($info=$inDB->fetch_assoc($result))
        {
        	if($j=="0")
        	{
        		echo "<tr>";
        	}
		$usr = $inUser->loadUser($info['user_id']);
	echo '<td><div style="margin-top:5px;border:1px dotted #777;border-radius:5px;">
		<div style="padding:5px;background-color:#eee;">
	   		<h4><a href="/imagination/image'.$info['id'].'.html">Изображение №'.$info['id'].'</a></h4>
	   						
	   							
	   				
<table width="100%" style="padding-bottom:15px;width:100%;background-color:#fff;">
							<tr>
							<td width="150" align="center">
								'.$inUser->getGenderLink($info['user_id']).'
								<br/>
								<a href="/users/'.$usr['login'].'"><img src="'.$usr['imageurl'].'" style="margin:5px;background-color:#e1e1e1;border-radius:5px;" border="0" /></a><br/>
								'.$inCore->dateFormat($info['pubdate']).'
	   						</td>
	   						<td width="5%">
	   								<img src="/components/imagination/images/bullet_go.png" style="padding-bottom:30px;" border="0" />
	   						</td>
	   						<td >
	   						
	   							<a href="/imagination/image'.$info['id'].'.html"><img src="'.$info['thumbs'].'" alt="'.$info['title'].'" title="'.$info['title'].'" style="border-radius:5px;margin:5px;" border="0"/></a><br/><span style="font-size:11px;">Источник: <a href="'.$info['link'].'" style="font-size:11px;">'.$info['title'].'</a>
	   						</td>
</table>

	</div></div>
</td>';
	$j++;
	if($j==$jp)
	{
	echo "</tr>";
	$j=0;
	}
		}
		echo "</table>";
	echo $pagebar;


}

/*конец ПБ*/



/*пересчёт комментариев*/

/*конец ПК*/
//========================================================================================================================//
if ($do=='adminforum'){
	
	 $user_id = $inUser->id;
	//Получаем параметры
	if(cmsUser::isAdminCan($user_id))
	{
	if($cfg['show_forum']==1)
	{
	$i="0";
	$page_title="Изображения из форумов.  Пересчёт. ";
		$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);

	echo "<h3>".$page_title."</h3>";


$sql = "SELECT * FROM `cms_forum_posts` WHERE `content_html` LIKE '%src=\"/upload/%' order by pubdate";

        $result = $inDB->query($sql);
        while($info=$inDB->fetch_assoc($result))
        {
        	$forum=$inDB->get_fields('cms_forum_threads', "id='".$info['thread_id']."'", '*');
        	if (preg_match_all('/<img(?:\\s[^<>]*?)?\\bsrc\\s*=\\s*(?|"([^"]*)"|\'([^\']*)\'|([^<>\'"\\s]*))[^<>]*>/i', $info['content_html'], $m))
	   		{	foreach($m[1] as $im=>$m)
	   			{
	   			
				
				
		   		$string2 = 'upload';
				$res= strpos($m, $string2);
				   	if ($res=== false){}else{
				   		
				   		
				 /*прроверка существования в базе*/
				 $sql="select * from `cms_imagination` where `file`='".$m."';";
				 $res=$inDB->query($sql);
				 if($inDB->num_rows($res)<="0")
				 {
				   		$usr = $inUser->loadUser($info['user_id']);
				   		$size = getimagesize(PATH.$m);
				   		$thumbs="/upload/forum/small/".md5($m).".jpg";
			   			$link='/forum/thread'.$info['thread_id'].'.html';
			   			

				   		$sql="INSERT INTO `cms_imagination` (`id`, `file`, `thumbs`, `width`, `height`, `type`, `date`, `pubdate`, `title`, `seokey`, `seodesc`, `link`, `user_id`,`published`) VALUES (NULL, '".$m."', '".$thumbs."', '".$size['0']."', '".$size['1']."', 'forum', NOW(), '".$info['pubdate']."', '".$forum['title']."', '', '', '".$link."', '".$info['user_id']."','1');";
				   		//echo $sql."<br/>";
				   		$inDB->query($sql);
				   		$inCore->includeGraphics();
				   		/*создаём превью*/
						@img_resize(PATH.$m, PATH.$thumbs, 100, 100, 1);
						$i++;
				 }
				
				

		   			}
   				}
   			}
    	
        
       
        }
         echo "Пересчёт завершен! Добавлено записей: ".$i;
    }else{echo "Необходимо включить в админке пересчёт форума";}       
    }else { cmsCore::error404(); }
        	
}
//========================================================================================================================//
if ($do=='adminblogs'){

	 $user_id = $inUser->id;
	//Получаем параметры
	if(cmsUser::isAdminCan($user_id))
	{
	if($cfg['show_blogs']==1)
	{
	$i="0";
	$page_title="Изображения из блогов.  Пересчёт. ";
		$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);

	echo "<h3>".$page_title."</h3>";


$sql = "SELECT * FROM `cms_blog_posts` WHERE `content_html` LIKE '%src=\"/upload/%' order by pubdate";

        $result = $inDB->query($sql);
        while($info=$inDB->fetch_assoc($result))
        {
        	$blog=$inDB->get_fields('cms_blogs', "id='".$info['blog_id']."'", '*');
        	if (preg_match_all('/<img(?:\\s[^<>]*?)?\\bsrc\\s*=\\s*(?|"([^"]*)"|\'([^\']*)\'|([^<>\'"\\s]*))[^<>]*>/i', $info['content_html'], $m))
	   		{	foreach($m[1] as $im=>$m)
	   			{
	   			
				
				
		   		$string2 = 'upload';
				$res= strpos($m, $string2);
				   	if ($res=== false){}else{
				   		
				   		
				 /*прроверка существования в базе*/
				 $sql="select * from `cms_imagination` where `file`='".$m."';";
				 $res=$inDB->query($sql);
				 if($inDB->num_rows($res)<="0")
				 {
				   		$usr = $inUser->loadUser($info['user_id']);
				   		$size = getimagesize(PATH.$m);
				   		$thumbs="/upload/blogs/small/".md5($m).".jpg";
			   			$link='/blogs/'.$blog['seolink'].'/'.$info['seolink'].'.html';
			   			

				   		$sql="INSERT INTO `cms_imagination` (`id`, `file`, `thumbs`, `width`, `height`, `type`, `date`, `pubdate`, `title`, `seokey`, `seodesc`, `link`, `user_id`,`published`) VALUES (NULL, '".$m."', '".$thumbs."', '".$size['0']."', '".$size['1']."', 'blogs', NOW(), '".$info['pubdate']."', '".$info['title']."', '', '', '".$link."', '".$info['user_id']."','1');";
				   		//echo $sql."<br/>";
				   		$inDB->query($sql);
				   		$inCore->includeGraphics();
				   		/*создаём превью*/
						@img_resize(PATH.$m, PATH.$thumbs, 100, 100, 1);
						$i++;
				 }
				
				

		   			}
   				}
   			}
    	
        
       
        }
         echo "Пересчёт завершен! Добавлено записей: ".$i;
    }else{echo "Необходимо включить в админке пересчёт блогов";}   
    }else { cmsCore::error404(); }
	
}

//========================================================================================================================//
if ($do=='admincomments'){

	 $user_id = $inUser->id;
	//Получаем параметры
	if(cmsUser::isAdminCan($user_id))
	{
	if($cfg['show_comments']==1)
	{
		$i="0";
	$page_title="Изображения из комментариев.  Пересчёт. ";
		$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);

	echo "<h3>".$page_title."</h3>";


$sql = "SELECT * FROM `cms_comments` WHERE `content` LIKE '%src=\"/upload/%' and `published`='1' order by pubdate";

        $result = $inDB->query($sql);
        while($info=$inDB->fetch_assoc($result))
        {
        	if (preg_match_all('/<img(?:\\s[^<>]*?)?\\bsrc\\s*=\\s*(?|"([^"]*)"|\'([^\']*)\'|([^<>\'"\\s]*))[^<>]*>/i', $info['content'], $m))
	   		{	foreach($m[1] as $im=>$m)
	   			{
	   			
				
				
		   		$string2 = 'upload';
				$res= strpos($m, $string2);
				   	if ($res=== false){}else{
				   		
				   		
				 /*прроверка существования в базе*/
				 $sql="select * from `cms_imagination` where `file`='".$m."';";
				 $res=$inDB->query($sql);
				 if($inDB->num_rows($res)<="0")
				 {
				   		$usr = $inUser->loadUser($info['user_id']);
				   		$size = getimagesize(PATH.$m);
				   		$thumbs="/upload/comments/small/".md5($m).".jpg";
			   			$link=$info['target_link'];
			   			

				   		$sql="INSERT INTO `cms_imagination` (`id`, `file`, `thumbs`, `width`, `height`, `type`, `date`, `pubdate`, `title`, `seokey`, `seodesc`, `link`, `user_id`,`published`) VALUES (NULL, '".$m."', '".$thumbs."', '".$size['0']."', '".$size['1']."', 'comments', NOW(), '".$info['pubdate']."', '".$info['target_title']."', '', '', '".$link."', '".$info['user_id']."','1');";
				   		//echo $sql."<br/>";
				   		$inDB->query($sql);
				   		$inCore->includeGraphics();
				   		/*создаём превью*/
						@img_resize(PATH.$m, PATH.$thumbs, 100, 100, 1);
						$i++;
				 }
				
				

		   			}
   				}
   			}
    	
        
       
        }
         echo "Пересчёт завершен! Добавлено записей: ".$i;
    }else{echo "Необходимо включить в админке пересчёт комментариев";}        
    }else { cmsCore::error404(); }
      

}

//========================================================================================================================//
if ($do=='adminvstrechi'){

	 $user_id = $inUser->id;
	//Получаем параметры
	if(cmsUser::isAdminCan($user_id))
	{
	if($cfg['show_vstrechi']==1)
	{		
		$i="0";
	$page_title="Изображения из встреч/событий.  Пересчёт. ";
		$inPage->setTitle($page_title);
	$inPage->addPathway($page_title);

	echo "<h3>".$page_title."</h3>";


$sql = "SELECT * FROM `cms_vstrechi` WHERE `describe_full_html` LIKE '%src=\"/upload/%' and `published`='1' or `otchet_html` LIKE '%src=\"/upload/%' and `published`='1'order by pubdate";

        $result = $inDB->query($sql);
        while($info=$inDB->fetch_assoc($result))
        {
        	if (preg_match_all('/<img(?:\\s[^<>]*?)?\\bsrc\\s*=\\s*(?|"([^"]*)"|\'([^\']*)\'|([^<>\'"\\s]*))[^<>]*>/i', $info['describe_full_html'], $m))
	   		{	foreach($m[1] as $im=>$m)
	   			{
	   			
				
				
		   		$string2 = 'upload';
				$res= strpos($m, $string2);
				   	if ($res=== false){}else{
				   		
				   		
				 /*прроверка существования в базе*/
				 $sql="select * from `cms_imagination` where `file`='".$m."';";
				 $res=$inDB->query($sql);
				 if($inDB->num_rows($res)<="0")
				 {
				   		$usr = $inUser->loadUser($info['user_id']);
				   		$size = getimagesize(PATH.$m);
				   		$thumbs="/upload/vstrechi/small/".md5($m).".jpg";
$link="/vstrechi/category".$info['cat_id']."/vstrecha".$info['id'].".html";
			   			

				   			$sql="INSERT INTO `cms_imagination` (`id`, `file`, `thumbs`, `width`, `height`, `type`, `date`, `pubdate`, `title`, `seokey`, `seodesc`, `link`, `user_id`,`published`) VALUES (NULL, '".$m."', '".$thumbs."', '".$size['0']."', '".$size['1']."', 'vstrechi', NOW(), '".$info['pubdate']."', '".$info['title']."', '', '', '".$link."', '".$info['user_id']."','1');";
				   		//echo $sql."<br/>";
				   		$inDB->query($sql);
				   		$inCore->includeGraphics();
				   		/*создаём превью*/
						@img_resize(PATH.$m, PATH.$thumbs, 100, 100, 1);
						$i++;
				 }
				
				

		   			}
   				}
   			}
   			
   			
   			/**/
   				if (preg_match_all('/<img(?:\\s[^<>]*?)?\\bsrc\\s*=\\s*(?|"([^"]*)"|\'([^\']*)\'|([^<>\'"\\s]*))[^<>]*>/i', $info['otchet_html'], $m))
	   		{	foreach($m[1] as $im=>$m)
	   			{
	   			
				
				
		   		$string2 = 'upload';
				$res= strpos($m, $string2);
				   	if ($res=== false){}else{
				   		
				   		
				 /*прроверка существования в базе*/
				 $sql="select * from `cms_imagination` where `file`='".$m."';";
				 $res=$inDB->query($sql);
				 if($inDB->num_rows($res)<="0")
				 {
				   		$usr = $inUser->loadUser($info['user_id']);
				   		$size = getimagesize(PATH.$m);
				   		$thumbs="/upload/vstrechi/small/".md5($m).".jpg";
$link="/vstrechi/category".$info['cat_id']."/vstrecha".$info['id'].".html";
			   			

				   		$sql="INSERT INTO `cms_imagination` (`id`, `file`, `thumbs`, `width`, `height`, `type`, `date`, `pubdate`, `title`, `seokey`, `seodesc`, `link`, `user_id`,`published`) VALUES (NULL, '".$m."', '".$thumbs."', '".$size['0']."', '".$size['1']."', 'vstrechi', NOW(), '".$info['pubdate']."', '".$info['title']."', '', '', '".$link."', '".$info['user_id']."','1');";
				   		//echo $sql."<br/>";
				   		$inDB->query($sql);
				   		$inCore->includeGraphics();
				   		/*создаём превью*/
						@img_resize(PATH.$m, PATH.$thumbs, 100, 100, 1);
						$i++;
				 }
				
				

		   			}
   				}
   			}
   			/**/
    	
        
       
        }
         echo "Пересчёт завершен! Добавлено записей: ".$i;
}else{echo "Необходимо включить в админке пересчёт событий/встреч";}             
    }else { cmsCore::error404(); }
      

}

//==============================================================================
//

//
//==========================================//


echo "<p align='right' style='color:#7bb1c2;font-size:10px;font-family:Tahoma;'> разработка: <a href='http://www.svb28.ru' style='color:#7bb1c2;font-size:10px;font-family:Tahoma;' title='город Свободный Амурская область'>svb28.ru</a></p>";


///////////////////////////////
$inCore->do;
}
?>